
class PrecursorSort:
    def __init__(self,input,asc=True):
        self.asc = asc
        self.input = input

    def __iter__(self):
        return self.next()

    def next(self):
        spectra = list(self.input)
        spectra.sort(key = lambda s: s.get('precursorMz',None),reverse=(not self.asc))
        for s in spectra:
            yield s
            
            
