
import os
import gzip
import sys

def fopen(f,spec):
    if type(f) == str:
        if f.endswith('.gz'):
            if spec == 'r':
                h = gzip.open(f,'rb')
            elif spec == 'w':
                h = gzip.open(f,'wb')
            else:
                raise "Unsupported I/O spec: '%s'"%(spec,)
        elif f == '-':
            if spec == 'r':
                h = sys.stdin
            elif spec == 'w':
                h = sys.stdout
            else:
                raise "Unsupported I/O spec: '%s'"%(spec,)
        else:
            h = open(f,spec)
    elif type(f) == file:
        h = f
    return h

class charCounter:
    def __init__(self,h):
        self.h = h
        self.count = 0;

    def __getattr__(self,attr):
        return getattr(self.h,attr)

    def chars(self):
        return self.count

    def write(self,str):
        self.count += len(str);
        return self.h.write(str)
