
from fopen import *
from Spectrum import Spectrum

import os
import os.path

class DTADirWriter:
    def __init__(self,s,d):
        self.d = d
        self.s = s
        if not os.path.isdir(self.d):
            os.mkdir(self.d)
    def write(self,template="%(num)d.%(num)d",charges=None):
        for s in self.s:
            if s.get('precursorMz.precursorCharge',None):
                chargelist = [s.get('precursorMz.precursorCharge',None)]
            elif charges:
                chargelist = charges
            else:
                continue
            for c in chargelist:
                h = open(os.path.join(self.d,os.path.basename(self.d)+'.'+template%s.metadata()+'.%d.dta'%c),'w')
                h.write("%f %d\n"%(s.get('precursorMz')*c-(c-1),c));
                for (mz,it) in zip(s.mz(),s.it()):
                    h.write("%f %f\n"%(mz,it))
                h.close()
