
from fopen import *
from Spectrum import Spectrum
from cjson import *

class JSONWriter:
    def __init__(self,s,f):
        self.f = f
        self.s = s

    def write(self,spectitle=None):
        obj = {}
        obj['series'] = []
        for s1 in self.s:
            s = {}
            s['name'] = spectitle%s1.metadata()
            s['pairs'] = zip(s1.mz(),s1.it())
            s['precursor'] = s1.get('precursorMz')
            obj['series'].append(s)
        h = fopen(self.f,'w')
        h.write(encode(obj))
        h.close()               
