
class OrdinalFilter:
    def __init__(self,input):
        self.input = input
        self.reset()

    def reset(self):
        self.ordinal = 0
        self.input.reset()

    def __iter__(self):
        return self.next()

    def next(self):
        for s in self.input:
            self.ordinal += 1
            s.set('ordinal',self.ordinal)
            yield s
            


                
