
class ZeroFilter:
    def __init__(self,input):
        self.input = input

    def __iter__(self):
        return self.next()

    def next(self):
        for s in self.input:
            peaks = [ p for p in zip(s.mz(),s.it()) if p[0] > 0.0 and p[1] > 0.0 ] 
            if len(peaks) == 0:
                continue
            peaks.sort(key=lambda p: p[0])
            s.mz([p[0] for p in peaks])
            s.it([p[1] for p in peaks])
            yield s
            


                
